//package com.jz.common.utils.realTime;
//
//import com.jz.dmp.web.ui.modules.dmp.model.task.realtime.RealTimeSyncColumnModel;
//import com.jz.dmp.web.ui.modules.dmp.model.task.realtime.RealTimeSyncDataSourceModel;
//import com.jz.dmp.web.ui.modules.dmp.model.task.realtime.RealTimeSyncTableModel;
//import org.springframework.util.CollectionUtils;
//import org.springframework.util.StringUtils;
//
//import java.sql.*;
//import java.util.ArrayList;
//import java.util.HashMap;
//import java.util.List;
//import java.util.Map;
//
//public class DBUtil {
//
//
//
//	/**
//	 * 创建连接
//	 * @param driverName 驱动名称
//	 * @param jdbcUrl 连接字符串
//	 * @param username 用户名
//	 * @param password 密码
//	 * @return 获取的连接
//	 * @throws ClassNotFoundException
//	 * @throws SQLException
//	 */
//	public static Connection openConn(RealTimeSyncDataSourceModel realTimeSyncDataSourceModel) throws Exception {
//		String driverName = realTimeSyncDataSourceModel.getDriverName();
//		String jdbcUrl = realTimeSyncDataSourceModel.getJdbcUrl();
//		String username = realTimeSyncDataSourceModel.getUserName();
//		String password = realTimeSyncDataSourceModel.getPassword();
//		if (!StringUtils.isEmpty(driverName)){
//			Class.forName(driverName);
//		}
//        return  DriverManager.getConnection(jdbcUrl, username, password);
//    }
//
//    // 关闭数据库连接
//    public static void closeConn(Connection conn) {
//        try {
//            if (conn != null) {
//                conn.close();
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }
//
//
//   /**
//    * 获取数据库里的元数据信息
//    * @param connection 创建的数据库连接
//    * @return
//    * @throws Exception
//    */
//    public static DatabaseMetaData  getMetaData(Connection connection) throws Exception {
//    	if (connection != null) {
//			return connection.getMetaData();
//		}
//		return null;
//    }
//
//
//    /**
//     * 获取数据源里的所有表详细信息
//     * @param realTimeSyncDataSourceModel 根据数据源Id获取的数据源信息
//     * @param toQueryTableName 要查询的表明   如果为空,默认查询所有表
//     * @param isContainColumnInfo 是否包含列信息
//     * @param tableToTableSyncTasks 当前数据源已经同步过的表到表的任务
//     * @param blacklistTables 黑名单表
//     * @return
//     */
//    public static List<RealTimeSyncTableModel> getDataSourceTables(RealTimeSyncDataSourceModel realTimeSyncDataSourceModel, String toQueryTableName, boolean isContainColumnInfo, Map<String, Map<String, String>> tableToTableSyncTasksMap, String blacklistTables, String selectTablesName, Map<String, String> setttingBlacklistTableMap ){
//    	Connection connection = null;
//		try {
//			connection = openConn(realTimeSyncDataSourceModel);
//			DatabaseMetaData metaData = connection.getMetaData();
//	    	return getDataSourceTables(metaData, toQueryTableName, isContainColumnInfo,tableToTableSyncTasksMap,blacklistTables,selectTablesName,setttingBlacklistTableMap);
//		} catch (Exception e) {
//			e.printStackTrace();
//		}finally {
//			closeConn(connection);
//		}
//
//		return null;
//    }
//
//    /**
//     * 获取数据源里的表信息
//     * @param metaData 数据库源数据
//     * @param toQueryTableName 要查询的表明   如果为空,默认查询所有表
//     * @param isContainColumnInfo 是否包含列信息
//     * @param tableToTableSyncTasksMap  当前表已经存在的任务
//     * @param blacklistTables 前台设置后  传递到后台的黑名单表 ，如果在黑名单内  不返回当前表的信息
//     * @param selectTablesName 选择的要同步的表
//     * @return
//     * @throws Exception
//     */
//    public static List<RealTimeSyncTableModel> getDataSourceTables(DatabaseMetaData metaData, String toQueryTableName, boolean isContainColumnInfo, Map<String, Map<String, String>> tableToTableSyncTasksMap, String blacklistTables, String selectTablesName, Map<String, String> setttingBlacklistTableMap ) throws Exception{
//
//    	List<RealTimeSyncTableModel> dataSourceTables = null;
//    	if (metaData != null) {
//    		String tableNamePattern = "%";
//    		if (!StringUtils.isEmpty(toQueryTableName)) {
//				tableNamePattern = toQueryTableName+"%";
//			}
//    		ResultSet tables = metaData.getTables(null, "%", tableNamePattern, new String[] {"TABLE"});
//    		if (tables.wasNull()) {
//    			return dataSourceTables;
//    		}
//
//    		//选择查询的表
//    		Map<String, String> selectTableMap = null;
//
//    		if (!StringUtils.isEmpty(selectTablesName)) {
//				selectTableMap = new HashMap<>();
//				String [] selectTableArr = selectTablesName.split(",");
//				for (String selectTableName : selectTableArr) {
//					selectTableMap.put(selectTableName, selectTableName);
//				}
//			}
//
//    		//返回信息中不包含的表
//    		Map<String, String> notIncludeTableMap  = null;
//    		//判断表是否在黑名单表
//			if (!StringUtils.isEmpty(blacklistTables)) {
//				notIncludeTableMap = new HashMap<>();
//				String [] blacklistTablesArr = blacklistTables.split(",");
//				for (String blacklistTable : blacklistTablesArr) {
//					notIncludeTableMap.put(blacklistTable, blacklistTable);
//				}
//			}
//
//			dataSourceTables = new ArrayList<>();
//			RealTimeSyncTableModel realTimeSyncTableModel = null;
//			while (tables.next()) {
//
//				//表名
//				String tableName = tables.getString("TABLE_NAME");
//
//				String schema = tables.getString("TABLE_SCHEM");
//				//sqlServer  过滤sys表  只要dbo的表
//				if ("sys".equals(schema)) {
//					continue;
//				}
//
//				//已经选择的表
//				if (!CollectionUtils.isEmpty(selectTableMap) && !selectTableMap.containsKey(tableName)) {
//					//当前表不在选择的表内  不继续构造信息
//					continue;
//				}
//
//				//选择的黑名单
//				if (!CollectionUtils.isEmpty(notIncludeTableMap) && notIncludeTableMap.containsKey(tableName)) {
//					notIncludeTableMap.remove(tableName);
//					continue;
//				}
//
//
//				realTimeSyncTableModel = new RealTimeSyncTableModel();
//				realTimeSyncTableModel.setTableName(tableName);
//				//判断表的记录在同步任务中是否存在记录,如果已经存在,说明同步过
//				String desensitizationField = null ;
//				if (!CollectionUtils.isEmpty(tableToTableSyncTasksMap) && tableToTableSyncTasksMap.containsKey(tableName)) {
//						realTimeSyncTableModel.setIsSubmited(true);
//						//desensitization_field,脱敏字段
//						//算法  arithmetic
//						Map<String, String> tempMap = tableToTableSyncTasksMap.get(tableName);
//						desensitizationField = tempMap.get("desensitization_field");
//						String arithmetic = tempMap.get("arithmetic");
//						realTimeSyncTableModel.setDesensitizationField(desensitizationField);
//						realTimeSyncTableModel.setArithmetic(arithmetic);
//				}
//
//				//判断表是否在设置的黑名单中  如果有，说明已经在黑名单中   设置成true，返回给前端
//				if (!CollectionUtils.isEmpty(setttingBlacklistTableMap) && setttingBlacklistTableMap.containsKey(tableName)) {
//					realTimeSyncTableModel.setIsBlacklist(true);
//				}
//
//				//主键
//				String pkName = getPrimaryKeyColumnByTableName(metaData, tableName);
//				realTimeSyncTableModel.setPkName(pkName);
//
//				//是否包含列信息
//				if (isContainColumnInfo) {
//					Map<String, String > desensitizationFieldMap = null;
//					if (!StringUtils.isEmpty(desensitizationField)) {
//						desensitizationFieldMap = new HashMap<>();
//						String [] desensitizationFieldArr = desensitizationField.split(",");
//						for (String desensitizationFieldName : desensitizationFieldArr) {
//							selectTableMap.put(desensitizationFieldName, desensitizationFieldName);
//						}
//					}
//					realTimeSyncTableModel.setColumnInfo(getColumnInfoByTableName(metaData, tableName,desensitizationFieldMap));
//				}
//				dataSourceTables.add(realTimeSyncTableModel);
//			}
//
//		}
//    	return dataSourceTables;
//    }
//
//    /**
//     * 获取当前表里  设置主键的列名
//     * @param metaData
//     * @param tableName
//     * @return
//     * @throws Exception
//     */
//    public static String getPrimaryKeyColumnByTableName(DatabaseMetaData metaData,String tableName) throws Exception {
//    	if (metaData == null) {
//			return null;
//		}
//
//    	ResultSet pkResultSet = metaData.getPrimaryKeys(null, null, tableName);
//
//    	String primaryKey = "";
//    	while (pkResultSet.next()) {
//			primaryKey += pkResultSet.getString("COLUMN_NAME")+",";
//		}
//
//    	if (StringUtils.isEmpty(primaryKey)){
//    	    //没有设置主键  但是设置了唯一索引
//            ResultSet indexResultSet = metaData.getIndexInfo(null, null, "yyy3", true, false);
//            while (indexResultSet.next()){
//                primaryKey += indexResultSet.getString("COLUMN_NAME")+",";
//            }
//        }
//
//        if (!StringUtils.isEmpty(primaryKey)) {
//            primaryKey = primaryKey.substring(0, primaryKey.length() - 1);
//        }
//
//    	return primaryKey;
//    }
//
//    /**
//     * 获取当前表的所有列  以及是字符串的列
//     * @param metaData
//     * @param tableName
//     * @throws Exception
//     */
//    public static RealTimeSyncColumnModel getColumnInfoByTableName(DatabaseMetaData metaData, String tableName, Map<String, String> desensitizationFieldMap) throws Exception {
//    	RealTimeSyncColumnModel realTimeSyncColumnModel = null ;
//    	ResultSet columnResult = metaData.getColumns(null, "%", tableName,"%");
//    	if (!columnResult.wasNull()) {
//    		realTimeSyncColumnModel = new RealTimeSyncColumnModel();
//			List<String> allColumns = new ArrayList<>();
//
//
//			List<Map<String, Object>> strColumns = new ArrayList<>();
//			Map<String, Object> tempMap = null ;
//
//			while (columnResult.next()) {
//				//列名
//				String columnName = columnResult.getString("COLUMN_NAME");
//				allColumns.add(columnName);
//				//列类型
//				String columnType = columnResult.getString("TYPE_NAME");
//		        if (isStringColumn(columnType)) {
//		        	tempMap = new HashMap<>();
//		        	tempMap.put("columnName", columnName);
//		        	if (!CollectionUtils.isEmpty(desensitizationFieldMap) && desensitizationFieldMap.containsKey(columnName)) {
//		        		tempMap.put("isDesensitization", true);
//					}
//		        	strColumns.add(tempMap);
//			    }
//			}
//			realTimeSyncColumnModel.setAllColumns(null);
//			realTimeSyncColumnModel.setStrColumns(strColumns);
//			realTimeSyncColumnModel.setTableName(tableName);
//		}
//    	return realTimeSyncColumnModel;
//    }
//
//    /**
//     * 判断列是否是字符串类型的列
//     * @param columnType
//     * @return
//     */
//    private static boolean isStringColumn(String columnType) {
//    	columnType = columnType.toLowerCase();
//    	 if (columnType.equals("varchar")
//	        		|| columnType.equals("nvarchar")
//	                || columnType.equals("char")
//	                || columnType.equals("tinytext")
//	                || columnType.equals("text")
//	                || columnType.equals("mediumtext")
//	                || columnType.equals("longtext")
//	                ) {
//	          return true ;
//		 }
//    	 return false;
//    }
//
//
//    public static void main(String[] args) {
//
//    	String aa = "aa,bb,";
//
//    	System.err.println(aa.substring(0,aa.length()-1));
//
//    	String driverName = "com.mysql.jdbc.Driver";
//    	String jdbcUrl = "jdbc:mysql://10.0.53.179:3306/testunique";
//    	String username = "root";
//    	String password = "jz@2018";
//
//    	RealTimeSyncDataSourceModel realTimeSyncDataSourceModel = new RealTimeSyncDataSourceModel();
//    	realTimeSyncDataSourceModel.setDriverName(driverName);
//    	realTimeSyncDataSourceModel.setJdbcUrl(jdbcUrl);
//    	realTimeSyncDataSourceModel.setUserName(username);
//    	realTimeSyncDataSourceModel.setPassword(password);
//
//    	String blacklistTables = "";
//    	Map<String, Map<String, String>> map = null;
//    	Connection connection = null ;
//    	try {
//    		connection = openConn(realTimeSyncDataSourceModel);
//        	DatabaseMetaData metaData = getMetaData(connection);
//
//
//            ResultSet indexResultSet = metaData.getIndexInfo(null, null, "yyy3", true, false);
//
//            String primaryKey = "";
//            while (indexResultSet.next()){
//                primaryKey += indexResultSet.getString("COLUMN_NAME")+",";
//            }
//
//            if (!StringUtils.isEmpty(primaryKey)) {
//                primaryKey = primaryKey.substring(0, primaryKey.length() - 1);
//            }
//            System.err.println(primaryKey);
//
//            /*ResultSet resultSet = metaData.getColumns(null,"%","yyy3","%");
//           while (resultSet.next()){
//               System.err.println(resultSet.getString("COLUMN_NAME") +"--"+resultSet.getString("TYPE_NAME"));
//            }*/
//
//           String key = getPrimaryKeyColumnByTableName(metaData,"yyy3");
//
//           System.err.println("key--"+key);
//
//        } catch (Exception e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}finally {
//			closeConn(connection);
//		}
//	}
//
//
//}
